commit b1bc9dba5c720b67d19df4d94634bb89ad5ade23
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Tue Dec 7 18:46:52 2021

    Fortran: catch failed simplification of bad stride expression
    
    gcc/fortran/ChangeLog:
    
            PR fortran/103588
            * array.c (gfc_ref_dimen_size): Do not generate internal error on
            failed simplification of stride expression; just return failure.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/103588
            * gfortran.dg/pr103588.f90: New test.
    
    (cherry picked from commit 652c28736209f10bac1aa7ecb31f9056b518dacf)

diff --git a/gcc/fortran/array.c b/gcc/fortran/array.c
index e6bc045546f..addd0ba5a56 100644
--- a/gcc/fortran/array.c
+++ b/gcc/fortran/array.c
@@ -2405,12 +2405,11 @@ gfc_ref_dimen_size (gfc_array_ref *ar, int dimen, mpz_t *result, mpz_t *end)
 	{
 	  stride_expr = gfc_copy_expr(ar->stride[dimen]); 
 
-	  if(!gfc_simplify_expr(stride_expr, 1))
-	    gfc_internal_error("Simplification error");
-
-	  if (stride_expr->expr_type != EXPR_CONSTANT
-	      || mpz_cmp_ui (stride_expr->value.integer, 0) == 0)
+	  if (!gfc_simplify_expr (stride_expr, 1)
+	     || stride_expr->expr_type != EXPR_CONSTANT
+	     || mpz_cmp_ui (stride_expr->value.integer, 0) == 0)
 	    {
+	      gfc_free_expr (stride_expr);
 	      mpz_clear (stride);
 	      return false;
 	    }
diff --git a/gcc/testsuite/gfortran.dg/pr103588.f90 b/gcc/testsuite/gfortran.dg/pr103588.f90
new file mode 100644
index 00000000000..198e1766cd2
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/pr103588.f90
@@ -0,0 +1,8 @@
+! { dg-do compile }
+! PR fortran/103588 - ICE: Simplification error in gfc_ref_dimen_size
+! Contributed by G.Steinmetz
+
+program p
+  integer, parameter :: a(:) = [1,2] ! { dg-error "cannot be automatic or of deferred shape" }
+  integer :: b(2) = a(::a(1))        ! { dg-error "Invalid" }
+end

